<?php
/**
 * The template for displaying the footer
 *
 * Contains the opening of the #site-footer div and all content after.
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package WordPress
 * @subpackage Trademark Lawyer
 * @since Trademark Lawyer 1.0
 */

?>
<?php 
    if ( function_exists( 'ot_get_option' ) ) {
        $facebook = ot_get_option( 'facebook_link' );
        $twitter = ot_get_option( 'twitter_link' );
        $linkedin = ot_get_option( 'linkedin_link' );
        $sitelink = ot_get_option( 'site_link' );
    }
?>
	    <!--Begin Footer section-->
        <footer class="footer-container">
             <div class="wrapper">
                <div class="row">
                    <div class="col-12">
                        <div class="footer-top">
                            <div class="logo-outercon">
                                <a href="<?php echo esc_url( home_url( '/' ) ); ?>"><img src="<?php echo get_template_directory_uri(); ?>/assets/images/footer_logo.png" alt="logo"></a>
                            </div>
                            <div class="social-icons">
                                <ul>
                                    <li><a href="<?php echo $facebook; ?>" target="_blank"><i class="fab fa-facebook-f"></i></a></li>
                                    <li><a href="<?php echo $twitter; ?>" target="_blank"><i class="fab fa-twitter"></i></a></li>
                                    <li><a href="<?php echo $linkedin; ?>" target="_blank"><i class="fab fa-linkedin-in"></i></a></li>
                                </ul>
                            </div>
                        </div>
                        <div class="footer-bottom">
                            <?php wp_nav_menu(array('menu' => 'Footer Menu' , 'container' => 'ul'));?>
                            <div class="copyright">
                                <p>All righte reserved &copy; <a href="<?php echo $sitelink; ?>" target="_blank"><?php echo date("Y"); ?> trademarklawyer.com.au</a></p>
                            </div>
                        </div>
                    </div> 
                </div>
            </div>
        </footer> 
        <!--End Footer section--> 
    </div>

		<?php wp_footer(); ?>

	</body>
</html>
