<?php
/**
 * The front page template file
 *
 * If the user has selected a static page for their homepage, this is what will
 * appear.
 * Learn more: https://codex.wordpress.org/Template_Hierarchy
 *
 * @package WordPress
 * @subpackage Trademark Lawyer
 * @since 1.0.0
 */

get_header(); ?>

    <main class="content-container">
            <!--Banner section-->
            <section class="banner-container">
                <div class="banner-image">
                    <?php if ( has_post_thumbnail() ) : ?>
                        <?php the_post_thumbnail(); ?>
                    <?php else: ?>
                    <img src="<?php echo get_template_directory_uri(); ?>/assets/images/content/banner_image.jpg" alt="banner">
                    <?php endif; ?>
                </div>
                <div class="banner-content">
                    <div class="wrapper">
                        <div class="row">
                            <div class="col-12">
                                <div class="banner-inner">
                                    <?php the_field("banner_content"); ?>
                                    <div class="btn-blk">
                                        <a href="<?php the_field('register_now', 'option'); ?>" target="_blank" class="button">Register Now</a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </section> 
            <!--Banner section-->
            
            <!--About section-->
            <section class="about-content" id="trademark">  
                <div class="wrapper">
                    <div class="row">
                        <div class="col-12"> 
                            
                            <?php $post_object = get_field('select_about_trademark');

                            if( $post_object ): 

                                // override $post
                                $post = $post_object;
                                setup_postdata( $post ); 

                                ?>
                                <div class="title-block">
                                    <h6><?php the_title(); ?></h6>
                                    <?php if ( get_field('main_head') ): ?>
                                        <h2><?php the_field('main_head'); ?></h2>
                                    <?php endif ;?>
                                </div>
                                <?php the_content(); ?>
                                <?php wp_reset_postdata(); ?>
                            <?php endif; ?>
                            
                        </div>
                    </div>
                </div>
            </section>
            <!--About section-->
            
            <!--Adavantages section-->
            <section class="list-block-outer" id="advantages">
                <div class="wrapper">
                    <div class="row">
                        <div class="col-12">
                            <div class="list-block-inner">
                                <?php $post_object = get_field('select_advantages');

                                if( $post_object ): 

                                    // override $post
                                    $post = $post_object;
                                    setup_postdata( $post ); 

                                    ?>
                                    <div class="title-block">
                                        <h6><?php the_title(); ?></h6>
                                        <?php if ( get_field('main_head') ): ?>
                                            <h2><?php the_field('main_head'); ?></h2>
                                        <?php endif ;?>
                                    </div>
                                    <?php the_content(); ?>
                                    <div class="list-block">
                                        <?php if( have_rows('advantages_list') ): ?>
                                            <ul>
                                            <?php while( have_rows('advantages_list') ): the_row(); 
                                                $image = get_sub_field('icon');
                                                $content = get_sub_field('content');
                                                ?>
                                                <li>
                                                    <div class="list-item">
                                                        <div class="icon-blk">
                                                            <img src="<?php echo $image['url']; ?>" alt="<?php echo $image['alt'] ?>">
                                                        </div>
                                                        <?php echo $content;?>
                                                    </div>
                                                </li>
                                            <?php endwhile; ?>
                                            </ul>
                                        <?php endif; ?>
                                    </div>
                                    <?php wp_reset_postdata(); ?>
                                <?php endif; ?>
                                
                            </div>
                        </div>
                    </div>
                </div>
            </section>
            <!--Adavantages section-->
        
            <!--Why choose section-->
            <section class="why-choose-block" id="choose">
                <div class="wrapper">
                    <div class="row">
                        <div class="col-12">
                            <div class="why-choose-inner">
                                <?php $post_object = get_field('select_why_choose_us');

                                if( $post_object ): 

                                    // override $post
                                    $post = $post_object;
                                    setup_postdata( $post ); 

                                    ?>
                                    <div class="title-block">
                                        <h6><?php the_title(); ?></h6>
                                        <?php if ( get_field('main_head') ): ?>
                                            <h2><?php the_field('main_head'); ?></h2>
                                        <?php endif ;?>
                                    </div>
                                    <div class="two-column-block">
                                        <div class="left-block">
                                            <div class="image-block">
                                                <?php if ( has_post_thumbnail() ) : ?>
                                                    <?php the_post_thumbnail(); ?>
                                                <?php else: ?>
                                                <img src="<?php echo get_template_directory_uri(); ?>/assets/images/content/person.png" alt="banner">
                                                <?php endif; ?>
                                            </div>
                                        </div>
                                        <div class="right-block">
                                            <div class="listing">
                                                <?php if( have_rows('features_list') ): ?>
                                                <ul>
                                                <?php while( have_rows('features_list') ): the_row(); 
                                                    $image = get_sub_field('icon');
                                                    $content = get_sub_field('content');
                                                    ?>
                                                    <li>
                                                        <div class="icon-block">
                                                            <img src="<?php echo $image['url']; ?>" alt="<?php echo $image['alt'] ?>">
                                                        </div>
                                                        <div class="list-content">
                                                            <?php echo $content;?>
                                                        </div>
                                                    </li>
                                                <?php endwhile; ?>
                                                </ul>
                                            <?php endif; ?>
                                            </div>
                                            <a href="<?php the_field('register_now', 'option'); ?>" target="_blank" class="button">Register Now</a>
                                        </div>
                                    </div>
                                <?php wp_reset_postdata(); ?>
                                <?php endif; ?>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
            <!--Why choose section-->

            <!--Review section-->
            <section class="slider-container" id="reviews"> 
                <?php $post_object = get_field('select_reviews');

                if( $post_object ): 

                // override $post
                $post = $post_object;
                setup_postdata( $post ); 

                ?>
                <?php $image = get_field('slider_banner'); ?>
                <div class="slider-outer" style="background-image: url(<?php echo $image['url']; ?>)">
                    <div class="wrapper">
                        <div class="row">
                            <div class="col-12"> 
                                <div class="slider-inner">
                                    <div class="title-block">
                                        <h6><?php the_title(); ?></h6>
                                        <?php if ( get_field('main_head') ): ?>
                                            <h2><?php the_field('main_head'); ?></h2>
                                        <?php endif ;?>
                                    </div>
                                    <div class="slider-block">
                                        <div class="slider-blk">
                                            <?php if( have_rows('slider') ): ?>
                                                <?php while( have_rows('slider') ): the_row(); 
                                                    $name = get_sub_field('name');
                                                    $designation = get_sub_field('designation');
                                                    $content = get_sub_field('slider_content');
                                                    ?>
                                                    <div>
                                                        <?php echo $content;?>
                                                        <p><strong>- <?php echo $name;?></strong><?php echo $designation;?></p>
                                                    </div>
                                                <?php endwhile; ?>
                                            <?php endif; ?>

                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <?php wp_reset_postdata(); ?>
                <?php endif; ?>
            </section> 
            <!--Review section-->
            
            <!--FAQ section-->
            <section class="accordion-container" id="faq"> 
                <?php $post_object = get_field('select_faq');

                if( $post_object ): 

                // override $post
                $post = $post_object;
                setup_postdata( $post ); 

                ?>
                <div class="wrapper">
                    <div class="row">
                        <div class="col-12"> 
                            <div class="title-block">
                                <h6><?php the_title(); ?></h6>
                                <?php if ( get_field('main_head') ): ?>
                                    <h2><?php the_field('main_head'); ?></h2>
                                <?php endif ;?>
                            </div>
                            <div class="accordion-block">
                                <?php if( have_rows('accordion') ): ?>
                                    <?php while( have_rows('accordion') ): the_row(); 
                                        $title = get_sub_field('accordion_title');
                                        $content = get_sub_field('accordion_content');
                                        ?>
                                        <div class="acc-card">
                                            <div class="acc-title"><?php echo $title;?></div>
                                            <div class="acc-panel">
                                                <?php echo $content; ?>
                                            </div>
                                        </div>
                                    <?php endwhile; ?>
                                <?php endif; ?>
                            </div>
                        </div>
                    </div>
                </div>
                <?php wp_reset_postdata(); ?>
                <?php endif; ?>
            </section>
            <!--FAQ section-->
            
            <!--Contact section-->
            <section class="fullwidth-container"> 
                <div class="fullwidth-banner">
                    <?php $banner = get_field('register_banner'); ?>
                    <img src="<?php echo $banner['url']; ?>" alt="<?php echo $banner['alt'] ?>">
                </div>
                <div class="content-inner">
                    <div class="wrapper">
                        <div class="row">
                            <div class="col-12"> 
                                <?php the_field("register_content"); ?>
                                <div class="btn-blk">
                                        <a href="<?php the_field('register_now', 'option'); ?>" target="_blank" class="button">Register Now</a>
                                    </div>
                            </div>
                        </div>
                    </div>
                </div>
            </section>
            <!--Contact section-->
            
        </main>

<?php get_footer();