<?php
/**
 * Header file for the Trademark Lawyer WordPress default theme.
 *
 * @link https://developer.wordpress.org/themes/basics/template-files/#template-partials
 *
 * @package WordPress
 * @subpackage Trademark Lawyer
 * @since Trademark Lawyer 1.0
 */

?><!DOCTYPE html>

<html class="no-js" <?php language_attributes(); ?>>

	<head>

		<meta charset="<?php bloginfo( 'charset' ); ?>">
        <link rel="shortcut icon" href="<?php echo esc_url( get_template_directory_uri() ); ?>/favicon.ico" />
        <meta name="description" content="">
        <meta name="author" content="">
        <meta name="keywords" content="">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1.0" >
        <meta name="format-detection" content="telephone=no">
		<link rel="profile" href="https://gmpg.org/xfn/11">

		<?php
            wp_enqueue_script('jquery'); 
            wp_head(); 
        ?>
        
	</head>

	<body <?php body_class(); ?>>

		<?php
		wp_body_open();
		?>

		<div class="main-outercon"> 
        
        <!--Header section-->
        <header class="header-container">
            <div class="wrapper-large">
                <div class="row">
                    <div class="col-12">
                        <div class="header-wrap">
                            <div class="logo-outercon">
                                <a href="#"><img src="<?php echo get_template_directory_uri(); ?>/assets/images/logo.png" alt="logo"></a>
                            </div>
                            <div class="header-right">
                                <button class="hamburger-menu">
                                    <span></span>
                                    <span></span>
                                    <span></span>
                                </button>
                                <div class="main-menu">
                                    <?php wp_nav_menu(array('menu' => 'Main Menu' , 'container' => 'nav'));?>
                                </div>
                                <div class="btn-outer">
                                    <a href="<?php the_field('register_now', 'option'); ?>" target="_blank" class="button">Register Now</a>
                                </div>
                            </div>
                        </div>
                    </div> 
                </div>
            </div>
            
            <!-- offcanvas-menu-->            
            <div class="offcanvas-menu">
                <div class="mobile-menu">
                    <nav>
                        <ul>
                            <li><a href="#trademark">What Is Trademark?</a></li>
                            <li><a href="#advantages">Advantages</a></li>
                            <li><a href="#">Why Choose Us?</a></li>
                            <li><a href="#reviews">Reviews</a></li>
                            <li><a href="#faq">FAQs</a></li>
                        </ul>
                    </nav>
                </div>
                <div class="btn-outer">
                    <a href="<?php the_field('register_now', 'option'); ?>" target="_blank" class="button">Register Now</a>
                </div>
            </div>
            <div class="offcanvas-overlay"></div>
            <!-- offcanvas-menu-->     
        </header>

            
            
	
